/* gcc keyboard_client.c -o keyboard_client -lpthread -Wall -O3 */
#include <stdio.h>
#include <string.h>
#include <linux/input.h>
#include <unistd.h>
#include <pthread.h>

#define SLEEP_TIME 60
pthread_t ptkeyread_id;

char * filename;
char * keyboard_device;
FILE * keyboard_file;
FILE * data_file;
void * keyboard_read (void *);
struct input_event input;

void * keyboard_read (void * void_param) {
  bzero(&input, sizeof(struct input_event));
  unsigned short code_old = 0;
  unsigned int value_old = 0;
  while(1) {
    int result = fread ((void *)&input,1,sizeof(input), keyboard_file);
    if (result == 0) continue;
    if (((input.code != code_old) || (input.value != value_old)) &&
        ((input.value == 1) || (input.value == 0)) && (input.type == 1)) {
      data_file = fopen(filename,"a");
      if (data_file != NULL) {
        fprintf(data_file, "%li %li %i %i %i\n", input.time.tv_sec, input.time.tv_usec,
                input.type, input.code, input.value);
        fflush (data_file);
        fclose(data_file);
      }
      code_old = input.code, value_old = input.value;
    }
  }
};

int main (int argc, char * argv[]) {
  if (argc != 3) return 0;

  keyboard_device = argv[1];
  filename = argv[2];

  keyboard_file = fopen(keyboard_device,"r");
  if (keyboard_file == NULL) return 0;
  pthread_create (&ptkeyread_id, NULL, &keyboard_read, NULL);  

  while (1) {
    sleep(SLEEP_TIME);
  }
  fclose(keyboard_file);
  pthread_cancel(ptkeyread_id);
};
